unit ReplaceDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TReplaceDialogBox = class(TComponent)
  private
    { Private 錾 }
    FForm1: TForm;                // _CAO{bNXtH[
    FLabel1: TLabel;              //u : vx
    FComboBox1: TComboBox;        // ̃Xg
    FLabel2: TLabel;              //uu : vx
    FComboBox2: TComboBox;        // ũXg
    FFindItems: TStrings;         // FindItems vpeB̎QƃtB[h(= FComboBox1.Items)
    FReplaceItems: TStrings;      // ReplaceItems vpeB̎QƃtB[h(= FComboBox2.Items)
    FCheckBox1: TCheckBox;        // 啶Ə
    FCheckBox2: TCheckBox;        // G^[L[ŕXgɒǉ
    FCheckBox3: TCheckBox;        // ɕXgɒǉ
    FRadioGroup1: TRadioGroup;    // 
    FButton1: TButton;            //uv{^
    FButton2: TButton;            //uuĎɁv{^
    FButton3: TButton;            //uׂĒuv{^
    FButton4: TButton;            //uLZv{^
    FButton5: TButton;            //u폜v{^
    FButton6: TButton;            //uNA[v{^
    FEOption: Boolean;            // G^[L[ŕXgɒǉ
    FFOption: Boolean;            // ɕXgɒǉ
    FOnFind: TNotifyEvent;        // OnFind CxgtB[h(uv{^NbN)
    FOnReplaceFind: TNotifyEvent; // OnReplaceFind CxgtB[h(uuĎɁv{^NbN)
    FOnReplaceAll: TNotifyEvent;  // OnReplaceAll CxgtB[h(uׂĒuv{^NbN)
    FOnChangeFindText: TNotifyEvent;  // OnChangeFindText CxgtB[h
    FOnChangeReplaceText: TNotifyEvent;  // OnChangeReplaceText CxgtB[h
    FOnChangeDirection: TNotifyEvent; // OnChangeDirection CxgtB[h
    FOnChangeDivision: TNotifyEvent;  // OnChangeDivision CxgtB[h
    FOnShow: TNotifyEvent;            // OnShow CxgtB[h
    FOnClose: TCloseEvent;            // OnClose CxgtB[h
    function GetDirection: Boolean;
    function GetDivision: Boolean;
    function GetFindText: String;
    function GetFindItemIndex: Integer;
    function GetReplaceText: String;
    function GetReplaceItemIndex: Integer;
    function GetPPoint: TPoint;
    function GetSize: Integer;
    function GetTitle: String;
    function GetDialogWidth: Integer;
    function GetDialogHeight: Integer;
    procedure SetFindText(const Value: String);
    procedure SetFindItemIndex(const Value: Integer);
    procedure SetReplaceText(const Value: String);
    procedure SetReplaceItemIndex(const Value: Integer);
    procedure SetDirection(const Value: Boolean);
    procedure SetDivision(const Value: Boolean);
    procedure SetEOption(const Value: Boolean);
    procedure SetFOption(const Value: Boolean);
    procedure SetPPoint(const Value: TPoint);
    procedure SetSize(const Value: Integer);
    procedure SetTitle(const Value: String);
    procedure MakeForm;
    procedure SetFontSize;
    procedure Combo1Add;
    procedure Combo2Add;
  protected
    { Protected 錾 }
    procedure ComboBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ComboBox2Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    { Cxg\bh錾 }
    procedure DoFind; dynamic;
    procedure DoReplaceFind; dynamic;
    procedure DoReplaceAll; dynamic;
    procedure DoChangeFindText; dynamic;
    procedure DoChangeReplaceText; dynamic;
    procedure DoChangeDirection; dynamic;
    procedure DoChangeDivision; dynamic;
    procedure DoShow; dynamic;
    procedure DoClose(var Action: TCloseAction); dynamic;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Close; virtual;
    procedure Hide; virtual;
    procedure Show; virtual;
    procedure Execute; virtual;
    { vpeB錾 }
    property FindItems: TStrings read FFindItems;
    property ReplaceItems: TStrings read FReplaceItems;
    property PPoint: TPoint read GetPPoint write SetPPoint;
    property DialogWidth: Integer read GetDialogWidth;
    property DialogHeight: Integer read GetDialogHeight;
  published
    { Published 錾 }
    property Title: String read GetTitle write SetTitle;
    property FindText: String read GetFindText write SetFindText;
    property FindItemIndex: Integer read GetFindItemIndex write SetFindItemIndex;
    property ReplaceText: String read GetReplaceText write SetReplaceText;
    property ReplaceItemIndex: Integer read GetReplaceItemIndex write SetReplaceItemIndex;
    property Direction: Boolean read GetDirection write SetDirection default True;
    property Division: Boolean read GetDivision write SetDivision default True;
    property EOption: Boolean read FEOption write SetEOption default False;
    property FOption: Boolean read FFOption write SetFOption default False;
    property Size: Integer read GetSize write SetSize default 12;
    { Cxg錾 }
    property OnFind: TNotifyEvent read FOnFind write FOnFind;
    property OnReplaceFind: TNotifyEvent read FOnReplaceFind write FOnReplaceFind;
    property OnReplaceAll: TNotifyEvent read FOnReplaceAll write FOnReplaceAll;
    property OnChangeFindText: TNotifyEvent read FOnChangeFindText write FOnChangeFindText;
    property OnChangeReplaceText: TNotifyEvent read FOnChangeReplaceText write FOnChangeReplaceText;
    property OnChangeDirection: TNotifyEvent read FOnChangeDirection write FOnChangeDirection;
    property OnChangeDivision: TNotifyEvent read FOnChangeDivision write FOnChangeDivision;
    property OnShow: TNotifyEvent read FOnShow write FOnShow;
    property OnClose: TCloseEvent read FOnClose write FOnClose;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('ToolBox', [TReplaceDialogBox]);
end;
{ TReplaceDialogBox }

constructor TReplaceDialogBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FEOption := False;         // G^[L[ŕXgɒǉ
  FFOption := False;         // ɕXgɒǉ
  MakeForm;
  FComboBox1.OnKeyDown := ComboBox1KeyDown;
  FComboBox1.OnChange := ComboBox1Change;
  FComboBox2.OnKeyDown := ComboBox2KeyDown;
  FComboBox2.OnChange := ComboBox2Change;
  FFindItems := FComboBox1.Items;    // FindItems vpeB̎QƃtB[h
  FReplaceItems := FComboBox2.Items; // ReplaceItems vpeB̎QƃtB[h
  FCheckBox1.OnClick := CheckBox1Click;
  FCheckBox2.OnClick := CheckBox2Click;
  FCheckBox3.OnClick := CheckBox3Click;
  FRadioGroup1.OnClick  := RadioGroup1Click;
  FButton1.OnClick := Button1Click;
  FButton2.OnClick := Button2Click;
  FButton3.OnClick := Button3Click;
  FButton4.OnClick := Button4Click;
  FButton5.OnClick := Button5Click;
  FButton6.OnClick := Button6Click;
  FForm1.OnShow := FormShow;
  FForm1.OnClose := FormClose;
end;

destructor TReplaceDialogBox.Destroy;
begin
  inherited Destroy;
end;

procedure TReplaceDialogBox.Button1Click(Sender: TObject);
begin
  if FFOption then
    Combo1Add;
  DoFind;
end;

procedure TReplaceDialogBox.Button2Click(Sender: TObject);
begin
  DoReplaceFind;
end;

procedure TReplaceDialogBox.Button3Click(Sender: TObject);
begin
  DoReplaceAll;
end;

procedure TReplaceDialogBox.Button4Click(Sender: TObject);
begin
  FForm1.Close;
end;

procedure TReplaceDialogBox.Button5Click(Sender: TObject);
var
  i: Integer;
begin
  if FComboBox2.Focused then
  begin
    i := FComboBox2.ItemIndex;
    if i = -1 then
      i := FComboBox2.Items.IndexOf(FComboBox2.Text);
    if i <> -1 then
    begin
      FComboBox2.Items.Delete(i);
      if i = FComboBox2.Items.Count then
        Dec(i);
    end;
    FComboBox2.ItemIndex := i;
    if i = -1 then
      FComboBox2.Text := '';
  end
  else
  begin
    i := FComboBox1.ItemIndex;
    if i = -1 then
      i := FComboBox1.Items.IndexOf(FComboBox1.Text);
    if i <> -1 then
    begin
      FComboBox1.Items.Delete(i);
      if i = FComboBox1.Items.Count then
        Dec(i);
    end;
    FComboBox1.ItemIndex := i;
    if i = -1 then
      FComboBox1.Text := '';
  end;
end;

procedure TReplaceDialogBox.Button6Click(Sender: TObject);
begin
  if FComboBox2.Focused then
  begin
    FComboBox2.Items.Clear;
    FComboBox2.ItemIndex := -1;
    FComboBox2.Text := '';
  end
  else
  begin
    FComboBox1.Items.Clear;
    FComboBox1.ItemIndex := -1;
    FComboBox1.Text := '';
  end;
end;

procedure TReplaceDialogBox.CheckBox1Click(Sender: TObject);
begin
  DoChangeDivision;
end;

procedure TReplaceDialogBox.CheckBox2Click(Sender: TObject);
begin
  FEOption := FCheckBox2.Checked;
end;

procedure TReplaceDialogBox.CheckBox3Click(Sender: TObject);
begin
  FFOption := FCheckBox3.Checked;
end;

procedure TReplaceDialogBox.Close;
begin
  FForm1.Close;
end;

procedure TReplaceDialogBox.Combo1Add;
var
  i: Integer;
begin
  i := FComboBox1.Items.IndexOf(FComboBox1.Text);
  if i = -1 then
    FComboBox1.Items.Insert(0, FComboBox1.Text)
  else if i > 0 then
    FComboBox1.Items.Move(i, 0);
  FComboBox1.ItemIndex := 0;
end;

procedure TReplaceDialogBox.Combo2Add;
var
  i: Integer;
begin
  i := FComboBox2.Items.IndexOf(FComboBox2.Text);
  if i = -1 then
    FComboBox2.Items.Insert(0, FComboBox2.Text)
  else if i > 0 then
    FComboBox2.Items.Move(i, 0);
  FComboBox2.ItemIndex := 0;
end;

procedure TReplaceDialogBox.ComboBox1Change(Sender: TObject);
begin
  DoChangeFindText;
end;

procedure TReplaceDialogBox.ComboBox2Change(Sender: TObject);
begin
  DoChangeReplaceText;
end;

procedure TReplaceDialogBox.ComboBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = $0D) and (FComboBox1.Text <> '') then
  begin
    if FEOption then
      Combo1Add;
    DoFind;
  end;
end;

procedure TReplaceDialogBox.ComboBox2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if FEOption and (Key = $0D) and (FComboBox2.Text <> '') then
    Combo2Add;
end;

procedure TReplaceDialogBox.DoChangeDirection; // Cxg\bh
begin
  if Assigned(FOnChangeDirection) then
    FOnChangeDirection(Self); // CxgnȟĂяo
end;

procedure TReplaceDialogBox.DoChangeDivision; // Cxg\bh
begin
  if Assigned(FOnChangeDivision) then
    FOnChangeDivision(Self); // CxgnȟĂяo
end;

procedure TReplaceDialogBox.DoChangeFindText;
begin
  if Assigned(FOnChangeFindText) then
    FOnChangeFindText(Self); // CxgnȟĂяo
end;

procedure TReplaceDialogBox.DoChangeReplaceText;
begin
  if Assigned(FOnChangeReplaceText) then
    FOnChangeReplaceText(Self); // CxgnȟĂяo
end;

procedure TReplaceDialogBox.DoClose(var Action: TCloseAction); // Cxg\bh
begin
  if Assigned(FOnClose) then
    FOnClose(Self, Action); // CxgnȟĂяo
end;

procedure TReplaceDialogBox.DoFind; // Cxg\bh
begin
  if Assigned(FOnFind) then
    FOnFind(Self); // CxgnȟĂяo
end;

procedure TReplaceDialogBox.DoReplaceAll; // Cxg\bh
begin
  if Assigned(FOnReplaceAll) then
    FOnReplaceAll(Self); // CxgnȟĂяo
end;

procedure TReplaceDialogBox.DoReplaceFind; // Cxg\bh
begin
  if Assigned(FOnReplaceFind) then
    FOnReplaceFind(Self); // CxgnȟĂяo
end;

procedure TReplaceDialogBox.DoShow; // Cxg\bh
begin
  if Assigned(FOnShow) then
    FOnShow(Self); // CxgnȟĂяo
end;

procedure TReplaceDialogBox.Execute;
begin
  FForm1.Show;
end;

procedure TReplaceDialogBox.FormShow(Sender: TObject);
begin
  DoShow;
  FComboBox1.SetFocus;
end;

procedure TReplaceDialogBox.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DoClose(Action);
end;

function TReplaceDialogBox.GetDialogHeight: Integer;
begin
  Result := FForm1.Height;
end;

function TReplaceDialogBox.GetDialogWidth: Integer;
begin
  Result := FForm1.Width;
end;

function TReplaceDialogBox.GetDirection: Boolean;
begin
  if FRadioGroup1.ItemIndex = 0 then
    Result := False
  else // FRadioGroup1.ItemIndex = 1
    Result := True;
end;

function TReplaceDialogBox.GetDivision: Boolean;
begin
  Result := FCheckBox1.Checked;
end;

function TReplaceDialogBox.GetFindItemIndex: Integer;
begin
  Result := FComboBox1.ItemIndex;
end;

function TReplaceDialogBox.GetFindText: String;
begin
  Result := FComboBox1.Text;
end;

function TReplaceDialogBox.GetPPoint: TPoint;
begin
  Result := Point(FForm1.Left, FForm1.Top);
end;

function TReplaceDialogBox.GetReplaceItemIndex: Integer;
begin
  Result := FComboBox2.ItemIndex;
end;

function TReplaceDialogBox.GetReplaceText: String;
begin
  Result := FComboBox2.Text;
end;

function TReplaceDialogBox.GetSize: Integer;
begin // tH[̃TCYƂ̂́Aۂ́A-Form1.Font.Height łB
  Result := Abs(FForm1.Font.Height);
end;

function TReplaceDialogBox.GetTitle: String;
begin
  Result := FForm1.Caption;
end;

procedure TReplaceDialogBox.Hide;
begin
  FForm1.Hide;
end;

procedure TReplaceDialogBox.MakeForm;
var
  DialogUnits: TPoint;
begin
  FForm1 := TForm.Create(Application);
  with FForm1 do
  begin
    Canvas.Font := Font;
    DialogUnits := Point(Abs(Font.Height), Abs(Font.Height));
    BorderStyle := bsDialog;
    FormStyle := fsStayOnTop;
    ClientWidth := MulDiv(400, DialogUnits.X, 12);
    ClientHeight := MulDiv(180, DialogUnits.Y, 12);
    Left := Screen.Width div 2;
    Top := Screen.Height div 2;
    Caption := 'u';
    FLabel1 := TLabel.Create(FForm1);
    with FLabel1 do
    begin
      Parent := FForm1;
      Caption := ' : ';
      SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(12, DialogUnits.Y, 12),
                MulDiv(70, DialogUnits.X, 12), MulDiv(12, DialogUnits.Y, 12));
    end;
    FComboBox1 := TComboBox.Create(FForm1);
    with FComboBox1 do
    begin
      Parent := FForm1;
      SetBounds(MulDiv(80, DialogUnits.X, 12), MulDiv(8, DialogUnits.Y, 12),
                MulDiv(313, DialogUnits.X, 12), MulDiv(20, DialogUnits.Y, 12));
    end;
    FLabel2 := TLabel.Create(FForm1);
    with FLabel2 do
    begin
      Parent := FForm1;
      Caption := 'u : ';
      SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(40, DialogUnits.Y, 12),
                MulDiv(70, DialogUnits.X, 12), MulDiv(12, DialogUnits.Y, 12));
    end;
    FComboBox2 := TComboBox.Create(FForm1);
    with FComboBox2 do
    begin
      Parent := FForm1;
      SetBounds(MulDiv(80, DialogUnits.X, 12), MulDiv(36, DialogUnits.Y, 12),
                MulDiv(313, DialogUnits.X, 12), MulDiv(20, DialogUnits.Y, 12));
    end;
    FCheckBox1 := TCheckBox.Create(FForm1);
    with FCheckBox1 do
    begin
      Parent := FForm1;
      Caption := '啶Ə';
      Checked := True;
      SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(64, DialogUnits.Y, 12),
                MulDiv(145, DialogUnits.X, 12), MulDiv(17, DialogUnits.Y, 12));
    end;
    FCheckBox2 := TCheckBox.Create(FForm1);
    with FCheckBox2 do
    begin
      Parent := FForm1;
      Caption := 'G^[L[ŕXgɒǉ';
      Checked := False;
      SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(86, DialogUnits.Y, 12),
                MulDiv(217, DialogUnits.X, 12), MulDiv(17, DialogUnits.Y, 12));
    end;
    FCheckBox3 := TCheckBox.Create(FForm1);
    with FCheckBox3 do
    begin
      Parent := FForm1;
      Caption := 'ɕXgɒǉ';
      Checked := False;
      SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(108, DialogUnits.Y, 12),
                MulDiv(209, DialogUnits.X, 12), MulDiv(17, DialogUnits.Y, 12));
    end;
    FRadioGroup1 := TRadioGroup.Create(FForm1);
    with FRadioGroup1 do
    begin
      Parent := FForm1;
      Caption := '';
      FRadioGroup1.Items.Add('');
      FRadioGroup1.Items.Add('');
      FRadioGroup1.ItemIndex := 1;
      SetBounds(MulDiv(228, DialogUnits.X, 12), MulDiv(72, DialogUnits.Y, 12),
                MulDiv(65, DialogUnits.X, 12), MulDiv(49, DialogUnits.Y, 12));
    end;
    FButton1 := TButton.Create(FForm1);
    with FButton1 do
    begin
      Parent := FForm1;
      Caption := '';
      ModalResult := mrNone;
      SetBounds(MulDiv(309, DialogUnits.X, 12), MulDiv(64, DialogUnits.Y, 12),
                MulDiv(84, DialogUnits.X, 12), MulDiv(21, DialogUnits.Y, 12));
    end;
    FButton2 := TButton.Create(FForm1);
    with FButton2 do
    begin
      Parent := FForm1;
      Caption := 'uĎ';
      ModalResult := mrNone;
      SetBounds(MulDiv(309, DialogUnits.X, 12), MulDiv(92, DialogUnits.Y, 12),
                MulDiv(84, DialogUnits.X, 12), MulDiv(21, DialogUnits.Y, 12));
    end;
    FButton3 := TButton.Create(FForm1);
    with FButton3 do
    begin
      Parent := FForm1;
      Caption := 'ׂĒu';
      ModalResult := mrNone;
      SetBounds(MulDiv(309, DialogUnits.X, 12), MulDiv(120, DialogUnits.Y, 12),
                MulDiv(84, DialogUnits.X, 12), MulDiv(21, DialogUnits.Y, 12));
    end;
    FButton4 := TButton.Create(FForm1);
    with FButton4 do
    begin
      Parent := FForm1;
      Caption := 'LZ';
      ModalResult := mrNone;
      SetBounds(MulDiv(309, DialogUnits.X, 12), MulDiv(148, DialogUnits.Y, 12),
                MulDiv(84, DialogUnits.X, 12), MulDiv(21, DialogUnits.Y, 12));
    end;
    FButton5 := TButton.Create(FForm1);
    with FButton5 do
    begin
      Parent := FForm1;
      Caption := '폜';
      ModalResult := mrNone;
      SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(148, DialogUnits.Y, 12),
                MulDiv(75, DialogUnits.X, 12), MulDiv(21, DialogUnits.Y, 12));
    end;
    FButton6 := TButton.Create(FForm1);
    with FButton6 do
    begin
      Parent := FForm1;
      Caption := 'NA[';
      ModalResult := mrNone;
      SetBounds(MulDiv(96, DialogUnits.X, 12), MulDiv(148, DialogUnits.Y, 12),
                MulDiv(75, DialogUnits.X, 12), MulDiv(21, DialogUnits.Y, 12));
    end;
  end;
end;

procedure TReplaceDialogBox.RadioGroup1Click(Sender: TObject);
begin
  DoChangeDirection;
end;

procedure TReplaceDialogBox.SetDirection(const Value: Boolean);
begin
  if Value = False then
    FRadioGroup1.ItemIndex := 0
  else // Value = True
    FRadioGroup1.ItemIndex := 1;
  DoChangeDirection;
end;

procedure TReplaceDialogBox.SetDivision(const Value: Boolean);
begin
  FCheckBox1.Checked := Value;
  DoChangeDivision;
end;

procedure TReplaceDialogBox.SetEOption(const Value: Boolean);
begin
  FEOption := Value;
  FCheckBox2.Checked := Value;
end;

procedure TReplaceDialogBox.SetFOption(const Value: Boolean);
begin
  FFOption := Value;
  FCheckBox3.Checked := Value;
end;

procedure TReplaceDialogBox.SetFindText(const Value: String);
begin
  FComboBox1.Text := Value;
end;

procedure TReplaceDialogBox.SetFontSize;
var
  DialogUnits: TPoint;
begin
  with FForm1 do
  begin
    Canvas.Font := Font;
    DialogUnits := Point(Abs(Font.Height), Abs(Font.Height));
    ClientWidth := MulDiv(400, DialogUnits.X, 12);
    ClientHeight := MulDiv(180, DialogUnits.Y, 12);
  end;

  FLabel1.SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(12, DialogUnits.Y, 12),
          MulDiv(70, DialogUnits.X, 12), MulDiv(12, DialogUnits.Y, 12));

  FComboBox1.SetBounds(MulDiv(80, DialogUnits.X, 12), MulDiv(8, DialogUnits.Y, 12),
             MulDiv(313, DialogUnits.X, 12), MulDiv(20, DialogUnits.Y, 12));

  FLabel2.SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(40, DialogUnits.Y, 12),
          MulDiv(70, DialogUnits.X, 12), MulDiv(12, DialogUnits.Y, 12));

  FComboBox2.SetBounds(MulDiv(80, DialogUnits.X, 12), MulDiv(36, DialogUnits.Y, 12),
             MulDiv(313, DialogUnits.X, 12), MulDiv(20, DialogUnits.Y, 12));

  FCheckBox1.SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(64, DialogUnits.Y, 12),
             MulDiv(145, DialogUnits.X, 12), MulDiv(17, DialogUnits.Y, 12));

  FCheckBox2.SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(86, DialogUnits.Y, 12),
             MulDiv(217, DialogUnits.X, 12), MulDiv(17, DialogUnits.Y, 12));

  FCheckBox3.SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(108, DialogUnits.Y, 12),
             MulDiv(209, DialogUnits.X, 12), MulDiv(17, DialogUnits.Y, 12));

  FRadioGroup1.SetBounds(MulDiv(228, DialogUnits.X, 12), MulDiv(72, DialogUnits.Y, 12),
               MulDiv(65, DialogUnits.X, 12), MulDiv(49, DialogUnits.Y, 12));

  FButton1.SetBounds(MulDiv(309, DialogUnits.X, 12), MulDiv(64, DialogUnits.Y, 12),
           MulDiv(84, DialogUnits.X, 12), MulDiv(21, DialogUnits.Y, 12));

  FButton2.SetBounds(MulDiv(309, DialogUnits.X, 12), MulDiv(92, DialogUnits.Y, 12),
           MulDiv(84, DialogUnits.X, 12), MulDiv(21, DialogUnits.Y, 12));

  FButton3.SetBounds(MulDiv(309, DialogUnits.X, 12), MulDiv(120, DialogUnits.Y, 12),
           MulDiv(84, DialogUnits.X, 12), MulDiv(21, DialogUnits.Y, 12));

  FButton4.SetBounds(MulDiv(309, DialogUnits.X, 12), MulDiv(148, DialogUnits.Y, 12),
           MulDiv(84, DialogUnits.X, 12), MulDiv(21, DialogUnits.Y, 12));

  FButton5.SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(148, DialogUnits.Y, 12),
           MulDiv(75, DialogUnits.X, 12), MulDiv(21, DialogUnits.Y, 12));

  FButton6.SetBounds(MulDiv(96, DialogUnits.X, 12), MulDiv(148, DialogUnits.Y, 12),
           MulDiv(75, DialogUnits.X, 12), MulDiv(21, DialogUnits.Y, 12));
end;

procedure TReplaceDialogBox.SetFindItemIndex(const Value: Integer);
begin
  FComboBox1.ItemIndex := Value;
end;

procedure TReplaceDialogBox.SetPPoint(const Value: TPoint);
begin
  FForm1.Left := Value.X;
  FForm1.Top := Value.Y;
end;

procedure TReplaceDialogBox.SetReplaceItemIndex(const Value: Integer);
begin
  FComboBox2.ItemIndex := Value;
end;

procedure TReplaceDialogBox.SetReplaceText(const Value: String);
begin
  FComboBox2.Text := Value;
end;

procedure TReplaceDialogBox.SetSize(const Value: Integer);
begin
  if Value in [10..20] then
  begin
    FForm1.Font.Height := -Value;
    SetFontSize;
  end;
end;

procedure TReplaceDialogBox.SetTitle(const Value: String);
begin
  FForm1.Caption := Value;
end;

procedure TReplaceDialogBox.Show;
begin
  FForm1.Show;
end;

end.

